#extension GL_OES_standard_derivatives : enable

precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2; // mask texture
uniform int reverse;

#define BASE 0.2
#define DEBUG 0

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 textureColor2 = texture2D(inputImageTexture2, textureCoordinate2);
  
    if (DEBUG == 1) {
        gl_FragColor = textureColor2.rgaa;
    } else {
        float alpha = textureColor2.a;
        if (reverse == 0) {
            if (alpha > BASE) {
                gl_FragColor = textureColor;
            } else {
                gl_FragColor = vec4(0.0);
            }
        } else {
            if (alpha < BASE) {
                gl_FragColor = textureColor;
            } else {
                gl_FragColor = vec4(0.0);
            }
        }
    }
} 